-- Path repeater
-- By Fred Ruff
-- 
-- This utility will take a single object, create mulitple copies, and put them along a path with some control over
-- The ranomization of the path percent.
-- 
-- Num of copies = The number of copies of the object you want
-- Random Percent = This is th MAX number of percent the object will be in the path controller
-- GO!= computes the process
-- Randomize Values = will only work after the go button is pressed.  It will re randomize the percents

rollout pathr "Path Repeater" 
(
	local thing, spl
	local my_copies = #()


	Pickbutton pick_thing "Pick Object"
	Pickbutton pick_spl "Pick Spline"
	Spinner numcopies "Num of copies" range:[0,500,5] type:#integer
	Spinner pathoffset "Random Percent" range:[0,100,5] type:#integer
	Checkbox CV "Constant Velocity: " checked:false
	Button go "Go!"
	Button redo "Randomize values"
	group "Info"
	(
		Link email "By Fred Ruff"  address:"mailto:fred@ruff-stuff.com"
		Link www "www.ruff-stuff.com"  address:"http://www.ruff-stuff.com"
	)

on pick_thing picked obj do (thing = obj)
on pick_spl   picked sp do (spl = sp)


on go pressed do
	(
	undo on
		(
		thing.pos.controller= path follow:true
		thing.pos.controller.path = spl
		progressstart "Working"
		for i = 1 to numcopies.value do 
			(
				my_copies[i] = copy thing
				-- This will print the objects into the listener window
				-- format "my_copies[%] is %\n" i my_copies[i]
				animate on
					(
					r= random 1 pathoffset.value
					at time animationrange.start my_copies[i].pos.controller.percent = (i *r)
					at time animationrange.end   my_copies[i].pos.controller.percent = (i *r+animationrange.end)
					)
				progressupdate (i+ (100/numcopies.value))
			)
		Progressend()	
		)
	)
	

on redo pressed do
	( 
	progressstart "Working"
	for i = 1 to numcopies.value do 
		(
			animate on
					(
					r= random 1 pathoffset.value
					at time animationrange.start my_copies[i].pos.controller.percent = (i *r)
					at time animationrange.end   my_copies[i].pos.controller.percent = (i *r+animationrange.end)
					)
		progressupdate (i+ (100/numcopies.value))
		)
	Progressend()
	)

)
if floatpath != undefined do closerolloutfloater floatpath

		
floatpath = newRolloutFloater "Path Repeater" 250 300
addrollout pathr floatpath
